#![allow(dead_code)]

mod ast;
mod lexer;
mod parser;
mod tokens;

use crate::lexer::Lexer;
use crate::parser::Parser;

fn main() {
    println!("tokens = [");
    let text = "** 3.14 \"foo\" false true ( ) + += /* 1 /* 2 */ 3 */  // 4 \n 5";
    let lexer = Lexer::new(text);
    lexer.for_each(|token| {
        println!("    {:?},", token);
    });
    println!("]");

    let text2 = "1 + 2 * 3";
    let mut parser = Parser::new(text2, Lexer::new(text2));
    let expr = parser.parse_expr();
    println!("ast = {:#?}", expr);
}
